=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2008-10-25 19:26:49 +0000
+++ loggerhead/controllers/inventory_ui.py	2008-10-30 11:59:51 +0000
@@ -70,11 +70,10 @@
             file_id = history.get_file_id(revid, path)
         else:
             path = inv.id2path(file_id)
-        
+
         if file_id is None:
             file_id = inv.root.file_id
 
-
         idpath = inv.get_idpath(file_id)
         if len(idpath) > 1:
             updir = dirname(path)[1:]
@@ -95,6 +94,11 @@
                 raise HTTPServerError('Could not fetch changes')
 
             change = history.get_changes([ revid ])[0]
+            # If we're looking at the tip, use head: in the URL instead
+            if revid == history.last_revid:
+                revno_url = 'head:'
+            else:
+                revno_url = history.get_revno(revid)
             # add parent & merge-point branch-nick info, in case it's useful
             history.get_branch_nicks([ change ])
 
@@ -117,6 +121,7 @@
             'branch': self._branch,
             'util': util,
             'revid': revid,
+            'revno_url': revno_url,
             'change': change,
             'file_id': file_id,
             'path': path,

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-10-18 00:23:09 +0000
+++ loggerhead/templates/changelog.pt	2008-10-30 11:37:16 +0000
@@ -61,8 +61,7 @@
                   alt="collapse all" /> collapse all</a>
         </p>
         <!-- Table -->        
-        <table id="logentries"
-               tal:define="subcolspan python:4-bool(all_same_author)">
+        <table id="logentries">
             <tr class="logheader">
                 <td class="revisionnumber">Rev</td>
                 <td class="expandcell">&nbsp;</td>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-10-25 18:01:55 +0000
+++ loggerhead/templates/inventory.pt	2008-10-30 11:22:46 +0000
@@ -55,7 +55,7 @@
 
             <tr class="blueRow0" tal:condition="python:updir is not None">
                 <td class="summcell" colspan="6">
-                    <a tal:attributes="href python:url(['/files', change.revno, updir])" class="link">
+                    <a tal:attributes="href python:url(['/files', revno_url, updir])" class="link">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
                 </td>
             </tr>
@@ -63,12 +63,12 @@
             <!-- Show this if it's a directory -->
             <tal:block repeat="file filelist">
             <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='directory'">
-                <td class="autcell"><a tal:attributes="href python:url(['/files', change.revno], file.absolutepath)">
+                <td class="autcell"><a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_folder.gif');
                                              title string:Go to ${file/filename}" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/files', change.revno, file.absolutepath])" 
+                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])" 
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -91,7 +91,7 @@
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])" 
+                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -111,7 +111,7 @@
 
             <!-- Show this if it's a regular file -->
             <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='file'">
-                <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])">
+                <td class="autcell"><a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
                                              title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is False" />
@@ -121,7 +121,7 @@
                              tal:condition="python:file.executable is True" alt="File" />
                     </a>
 
-              <a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])"
+              <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])"
                                      tal:content="file/filename" class="link"></a></td>
               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
                                                   title string:Show revision ${file/change/revno}"
@@ -129,7 +129,7 @@
               </td>
               <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
               <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
-              <td class="expcell"><a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath]);
+              <td class="expcell"><a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath]);
                                                      title string:Annotate ${file/filename}">
                                       <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
                                      </a>

